<script lang="ts">
import Vue, { PropType } from 'vue';

interface metric {
  value: string;
  text: string;
}
interface cta {
  text: string;
  href: string;
}

export default Vue.extend({
  props: {
    title: {
      type: String,
      required: true,
    },
    gradientText: {
      type: String,
      required: true,
    },
    footerText: {
      type: String,
      required: true,
    },
    metrics: {
      type: Array as PropType<metric[]>,
      required: true,
    },
    cta: {
      type: Object as PropType<cta>,
      required: true,
    },
  },
});
</script>

<template>
  <SlpContainer>
    <div class="metrics-container">
      <SlpTypography class="title" tag="div" variant="heading2-bold">
        <p>{{ title }}</p>
        <p class="gradient">{{ gradientText }}</p>
      </SlpTypography>
      <div class="metrics">
        <div v-for="metric in metrics" :key="metric.text" class="metric">
          <p class="value">{{ metric.value }}</p>
          <SlpTypography variant="heading5-bold" class="text">{{
            metric.text
          }}</SlpTypography>
        </div>
      </div>
      <div class="footer">
        <SlpTypography variant="body1" class="text">{{
          footerText
        }}</SlpTypography>
      </div>
      <SlpButton :href="cta.href" variant="tertiary"
        >{{ cta.text }}
        <SlpIcon name="chevron-right" variant="product" />
      </SlpButton>
    </div>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.metrics-container {
  display: flex;
  position: relative;
  padding: 96px 0px;
  flex-direction: column;
  align-items: flex-start;
  gap: 30px;
  flex: 1 0 0;
  &:after {
    content: '';
    position: absolute;
    width: 200vw;
    height: 100%;
    top: 0;
    left: -50vw;
    z-index: -1;
    background: $color-surface-800;
  }
  .title {
    .gradient {
      background: linear-gradient(
        95deg,
        #e3995d -7.04%,
        #cb9296 4.35%,
        #7f48d6 50.29%
      );
      background-clip: text;
      -webkit-background-clip: text;
      -webkit-text-fill-color: transparent;
    }
  }
  .metrics {
    display: flex;
    justify-content: space-between;
    width: 100%;
    @media (max-width: $breakpoint-lg) {
      flex-direction: column;
    }
    .metric {
      display: flex;
      padding: 24px 0px;
      flex-direction: column;
      gap: 12px;
      flex: 1 0 0;
      .value {
        line-height: 96px;
        font-size: 96px;
        font-weight: 800;
        background: linear-gradient(
          91deg,
          rgba(227, 153, 93, 0.7) -13.29%,
          rgba(203, 146, 150, 0.7) -4.09%,
          rgba(127, 72, 214, 0.7) 66.61%
        );
        background-clip: text;
        -webkit-background-clip: text;
        -webkit-text-fill-color: transparent;
      }
    }
  }
  .footer {
    max-width: 450px;
    .text {
      color: $color-text-300;
    }
  }
}
</style>
